<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>
 "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    //base url
    const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    const gEND_OF_ROW_COL = -1;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        $("#btn-dice").click(function(){
            throwDice();
        })
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện thowDice
    function throwDice(){
        //khai báo biến userObj
        var vUserObj = {
            username:"",
            firstname: "",
            lastname:""
        };
        //b1: thu thập dữ liệu
        dataRead(vUserObj);
        //b2: kiểm tra dữ liệu
        var vThongTinHopLe = dataValidate(vUserObj);
        if (vThongTinHopLe){
            var vXmlHttpDice = new XMLHttpRequest();
            //b3: gọi API trả kết quả ném xúc xắc
            goiAPI(vUserObj, vXmlHttpDice);
            //b4: hiển thị kết quả
            vXmlHttpDice.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                    showDice(vXmlHttpDice);
                }
            }
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dữ liệu
    function dataRead(paramUserObj){
        //truy xuất phần tử input vàgán cho object
        paramUserObj.username = $("#inp-user-name").val().trim();
        paramUserObj.firstname = $("#inp-first-name").val().trim();
        paramUserObj.lastname = $("#inp-last-name").val().trim();
    }
    //hàm kiểm tra dữ liệu
    function dataValidate(paramUserObj){
        if(paramUserObj.username == "" ||
        paramUserObj.firstname == "" ||
        paramUserObj.lastname ==""){
            alert("Please input data!");
            return false;
        } else return true;
    }
    //hàm gọi API kết quả ném xúc xắc
    function goiAPI(paramUserObj, paramXmlHttp){
        paramXmlHttp.open("POST", vBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUserObj));  //chuyển Json object sang string
    }
    //hàm hiển thị xúc xắc
    function showDice(paramXmlHttp){
        console.log(paramXmlHttp.responseText);
        // parsing to object
        var vResponse = JSON.parse(paramXmlHttp.responseText);
        // get result dice
        var vDiceReady = vResponse.dice;
        console.log("dice result:= " + vDiceReady);
        var vThrowDiceMsg = $("#p-notification-dice");
        var vThrowDiceImg = $("#img-dice");
        //đổi lời nhắn
        if (vDiceReady > 3){
            vThrowDiceMsg.html("Chúc mừng");
            vThrowDiceMsg.show();
        } 
        else {
            vThrowDiceMsg.html("Chúc bạn may mắn hơn lần sau!");
            vThrowDiceMsg.show();
        }
        //đổi hình ảnh theo dice result
        if(vDiceReady == 1) {vThrowDiceImg.attr("src","LuckyDiceImages/1.png")};
        if(vDiceReady == 2) {vThrowDiceImg.attr("src","LuckyDiceImages/2.png")};
        if(vDiceReady == 3) {vThrowDiceImg.attr("src","LuckyDiceImages/3.png")};
        if(vDiceReady == 4) {vThrowDiceImg.attr("src","LuckyDiceImages/4.png")};
        if(vDiceReady == 5) {vThrowDiceImg.attr("src","LuckyDiceImages/5.png")};
        if(vDiceReady == 6) {vThrowDiceImg.attr("src","LuckyDiceImages/6.png")};
        // get voucher result
        var vVoucherReady = vResponse.voucher;
        var vVoucherId = $("#p-voucher-id");
        var vPhanTramGiamGia = $("#p-voucher-percent");
        if (vVoucherReady !== null){
            vVoucherId.html(vVoucherReady.id);
            vVoucherId.show();
            vPhanTramGiamGia.html(vVoucherReady.phanTramGiamGia + "%");
            vPhanTramGiamGia.show();
        }
        else {
            vVoucherId.html("Không có voucher");
            vVoucherId.show();
        }
        //get present result
        var vPrizeReady = vResponse.prize;
        var vPrizeImg = $("#img-present");
        if (vPrizeReady == null){
            vPrizeImg.attr("src", "LuckyDiceImages/no-present.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Sổ"){
            vPrizeImg.attr("src", "LuckyDiceImages/book.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Áo mưa"){
            vPrizeImg.attr("src", "LuckyDiceImages/ao-mua.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Xe đạp"){
            vPrizeImg.attr("src", "LuckyDiceImages/bike.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Bút"){
            vPrizeImg.attr("src", "LuckyDiceImages/but.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Ô tô"){
            vPrizeImg.attr("src", "LuckyDiceImages/car.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Mũ"){
            vPrizeImg.attr("src", "LuckyDiceImages/hat.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Áo phông"){
            vPrizeImg.attr("src", "LuckyDiceImages/t-shirt.jpg");
            vPrizeImg.show();
        }
        else if (vPrizeReady == "Xe máy"){
            vPrizeImg.attr("src", "LuckyDiceImages/xe-may.jpg");
            vPrizeImg.show();
        }
    }
</script>

</html>